// C Source File
// Created 28/06/2004; 16:02:55

#define USE_TI89              // Compile for TI-89

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

// Main Function
void _main(void)
{

	FILE * tiles;
	short nbPlans;
	short width;
	short height;
	char * line;
	register short i;
	
	if((tiles = fopen("main\\tiles","rb")))
	{
		fread(&nbPlans, sizeof(short), 1, tiles);
		fread(&width, sizeof(short), 1, tiles);
		fread(&height, sizeof(short), 1, tiles);
	
		printf ("%d %d %d", nbPlans, width, height);
	
		line = (char*)malloc(sizeof(unsigned char) * width);
	
		for(i = 0; fread(line, sizeof(unsigned char), width, tiles); i++)
		{
			if(i%height == 0)
			{
				ngetchx();
				clrscr();
			}
			memcpy (LCD_MEM + (i%height) * 30, line, width);
		}
	
	}
	else
	{
		ST_showHelp ("ERROR : NO INPUT FILE : tiles");
		ngetchx();		
	}
		
}
