// C Source File
// Created 02/11/2005; 11:04:50

#include "game.h"

unsigned char rdd[] = { // reverse digit data
// 00
	0xBB,
	0x55,
	0x55,
	0x55,
	0xBB,
// 11
	0xBB,
	0x33,
	0xBB,
	0xBB,
	0x11,
// 22
	0x33,
	0xDD,
	0xBB,
	0x77,
	0x11,
// 33
	0x33,
	0xDD,
	0xBB,
	0xDD,
	0x33,
// 44
	0x77,
	0x55,
	0x11,
	0xDD,
	0xDD,
// 55
	0x11,
	0x77,
	0x33,
	0xDD,
	0x33,
// 66
	0x99,
	0x77,
	0x11,
	0x55,
	0x11,
// 77
	0x11,
	0xDD,
	0xBB,
	0x77,
	0x77,
// 88
	0x11,
	0x55,
	0x11,
	0x55,
	0x11,
// 99
	0x11,
	0x55,
	0x11,
	0xDD,
	0x33,
};

#define PUTDIGIT \
	sor = *data++; \
	if(x&1) { \
		sor &= 0x0F; \
		sand = 0xF0; \
	} else { \
		sor &= 0xF0; \
		sand = 0x0F; \
	} \
	*pl0 &= sand; \
	*pl0 |= sor; \
	*pl1 &= sand; \
	*pl1 |= sor; \
	pl0 += 30; \
	pl1 += 30;

static inline void fd_ReverseGrayDrawDigit(unsigned char x, unsigned char y, unsigned char digit, unsigned char * pl0, unsigned char * pl1) {
	unsigned short offset = 30*y+(x>>1);
	digit = (digit<<2)+digit;
	unsigned char * data = rdd + digit;
	pl0 += offset;
	pl1 += offset;
	unsigned char sor,sand;

	PUTDIGIT
	PUTDIGIT
	PUTDIGIT
	PUTDIGIT
	PUTDIGIT
}

void fd_ReverseGrayDrawTime(unsigned char x, unsigned char y, unsigned short tick, unsigned char * pl0, unsigned char * pl1) {
	unsigned short t;
	t = (tick)/(256/GAME_SPEED)/60;
	fd_ReverseGrayDrawDigit(x++,y,t/10,pl0,pl1);
	fd_ReverseGrayDrawDigit(x,y,t%10,pl0,pl1);x+=2;
	t = (tick)/(256/GAME_SPEED)%60;
	fd_ReverseGrayDrawDigit(x++,y,t/10,pl0,pl1);
	fd_ReverseGrayDrawDigit(x,y,t%10,pl0,pl1);x+=2;
	t = (tick)%(256/GAME_SPEED);
	fd_ReverseGrayDrawDigit(x++,y,((t*100)/32)/10,pl0,pl1);
	fd_ReverseGrayDrawDigit(x,y,((t*100)/32)%10,pl0,pl1);
}

void fd_ReverseGrayDrawSpeed(unsigned char x, unsigned char y, unsigned short speed, unsigned char * pl0, unsigned char * pl1) {
	fd_ReverseGrayDrawDigit(x++,y,speed/1000,pl0,pl1); speed %= 1000;
	fd_ReverseGrayDrawDigit(x++,y,speed/100,pl0,pl1); speed %= 100;
	fd_ReverseGrayDrawDigit(x++,y,speed/10,pl0,pl1); speed %= 10;
	fd_ReverseGrayDrawDigit(x,y,speed,pl0,pl1);
}
