// C Source File
// Created 25/01/2003; 21:20:38

#include "target.h"
#if CALC == 89

#include "Mode7Engine.h"
#include "kbd.h"

unsigned short Keys[9]={0,0,0,0,0,0,0,0,0};
unsigned short Repeat_Keys[9]={0,0,0,0,0,0,0,0,0};

void kbd_Scan(void) {
	unsigned char column;
	unsigned short i;
	unsigned char mask;
	column = _rowread (0xFFFE);
	mask = 0x1;
	for(i=0;i<7;i++) {
		if(column & mask)
			Keys[i]=1;
		else
			Keys[i]=0;
		mask = mask<<1;
	}
	if((_rowread (0xFFFD)) & 1) Keys[7] = 1;
	else  Keys[7] = 0;
	if((_rowread (0xFFBF)) & 1) Keys[8] = 1;
	else  Keys[8] = 0;
}

void kbd_Repeat(void) {
	unsigned short i;

	kbd_Scan();
	for(i=0;i<9;i++) {
		if((Keys[i] == 0) || Repeat_Keys[i] == REPEAT)
			Repeat_Keys[i]=0;
		else
			Repeat_Keys[i]++;
	}
}

void kbd_Init(void) {
	SetIntVector (AUTO_INT_1, DUMMY_HANDLER);
	SetIntVector (AUTO_INT_5, DUMMY_HANDLER);
}

void kbd_End(void) {
	ReSetIntVector (AUTO_INT_1);
	ReSetIntVector (AUTO_INT_5);
}

#endif
