// C Source File
// Created 14/08/2004; 15:43:35

#include <tigcclib.h>
#define NBDIR 32
// Main Function

FILE * effect;

void putb(unsigned char num)
{
	fwrite (&num, 1, sizeof(unsigned char), effect);
}

void putw(unsigned short num)
{
	fwrite (&num, 1, sizeof(unsigned short), effect);
}

void puteffect(unsigned char type, unsigned char param)
{
	putb(((type & 0x7) << 5) | (param & 0x1f));
}

void puttag()
{
	fputc (0, effect);
	fputs ("TLFX", effect);
	fputc (0, effect);
	fputc (OTH_TAG, effect);
}

#define S (0)
#define N (NBDIR / 2)
#define O (3 * NBDIR / 4)
#define E (NBDIR / 4)
#define SO (7 * NBDIR / 8)
#define SE (NBDIR / 8)
#define NO (5 * NBDIR / 8)
#define NE (3 * NBDIR / 8)
#define SSO (15 * NBDIR / 16)
#define SOO (13 * NBDIR / 16)
#define SSE (NBDIR / 16)
#define SEE (3 * NBDIR / 16)
#define NNO (9 * NBDIR / 16)
#define NOO (11 * NBDIR / 16)
#define NNE (7 * NBDIR / 16)
#define NEE (5 * NBDIR / 16)

void _main(void)
{
	effect = fopen("tilesfx", "wb");
	putw(85);
	puteffect(1, E);
	puteffect(1, O);
	puteffect(1, S);
	puteffect(1, N);
	
	puteffect(1, SE);
	puteffect(1, SO);
	puteffect(1, NE);
	puteffect(1, NO);

	puteffect(1, SE);
	puteffect(1, SO);
	puteffect(1, NE);
	puteffect(1, NO);

	puteffect(1, E);
	puteffect(1, O);
	puteffect(1, E);
	puteffect(1, O);

	puteffect(1, S);
	puteffect(1, S);
	puteffect(1, N);
	puteffect(1, N);

	puteffect(1, NO);
	puteffect(1, NE);
	puteffect(1, SO);
	puteffect(1, SE);

	puteffect(1, NO);
	puteffect(1, NE);
	puteffect(1, SO);
	puteffect(1, SE);

	puteffect(1, NO);
	puteffect(1, NE);
	puteffect(1, SE);
	puteffect(1, SO);

	puteffect(1, NO);
	puteffect(1, NE);
	puteffect(1, SO);
	puteffect(1, SE);

	puteffect(1, NOO);
	puteffect(1, NEE);
	puteffect(1, SOO);
	puteffect(1, SEE);

	puteffect(1, NOO);
	puteffect(1, NEE);
	puteffect(1, SOO);
	puteffect(1, SEE);

	puteffect(1, NOO);
	puteffect(1, NEE);
	puteffect(1, SOO);
	puteffect(1, SEE);

	puteffect(1, NNO);
	puteffect(1, NNE);
	puteffect(1, SSO);
	puteffect(1, SSE);

	puteffect(1, NNO);
	puteffect(1, NNE);
	puteffect(1, SSO);
	puteffect(1, SSE);

	puteffect(1, NNO);
	puteffect(1, NNE);
	puteffect(1, SSO);
	puteffect(1, SSE);

	puteffect(6, 0);
	puteffect(5, 0);
	puteffect(6, 0);
	puteffect(6, 0);

	puteffect(6, 0);
	puteffect(6, 0);
	puteffect(6, 0);
	puteffect(6, 0);

	puteffect(4, 0);
	puteffect(4, 0);
	puteffect(4, 0);
	puteffect(4, 0);

	puteffect(2, 3);
	puteffect(2, 3);
	puteffect(2, 3);
	puteffect(2, 3);

	puteffect(2, 1);

	puteffect(3, 0);

	puteffect(2, 2);
	puteffect(0, 0);
	puteffect(0, 0);
	puteffect(0, 0);
	puteffect(0, 0);
	puteffect(0, 0);
	puteffect(0, 0);

	puttag();
	fclose(effect);
}
