// C Source File
// Created 31/01/2005; 20:31:12

#include <tigcclib.h>

// Main Function
void _main(void)
{
  ESI argptr;
  int argtype;
  FILE * tiles;
  FILE * tilexp;
  unsigned short nbplans, nbtiles, tilesize, nbchars, i, j;
	unsigned char c, co;
	
  InitArgPtr (argptr);
  if ((argtype = GetArgType (argptr)) == END_TAG)
  	return;
	if (argtype != STR_TAG)
		return;
	if ((tiles = fopen (GetStrnArg (argptr), "rb")) == NULL)
		return;
  if ((argtype = GetArgType (argptr)) == END_TAG)
  	return;
	if (argtype != STR_TAG)
		return;
	if ((tilexp = fopen (GetStrnArg (argptr), "wb")) == NULL)
		return;

	fread(&nbplans, sizeof(unsigned short), 1, tiles);
	fwrite(&nbtiles, sizeof(unsigned short), 1, tilexp);
	fread(&nbtiles, sizeof(unsigned short), 1, tiles);
	fwrite(&nbtiles, sizeof(unsigned short), 1, tilexp);
	fread(&tilesize, sizeof(unsigned short), 1, tiles);
	fwrite(&tilesize, sizeof(unsigned short), 1, tilexp);
	fread(&tilesize, sizeof(unsigned short), 1, tiles);
	fwrite(&tilesize, sizeof(unsigned short), 1, tilexp);

	nbchars = nbtiles * tilesize * tilesize / 8 * nbplans;

	for(i = 0; i < nbchars; i++) {
		fread(&c, sizeof(unsigned char), 1, tiles);
		for (j=0; j<8; j++)	{
			co = (c >> (7-j)) & 0x1;
			fwrite(&co, sizeof(unsigned char), 1, tilexp);
		}
	}

	while(fread(&c, sizeof(unsigned char), 1, tiles))
		fwrite(&c, sizeof(unsigned char), 1, tilexp);

}
