// C Source File
// Created 11/05/2003; 19:44:52

#include "game.h"

//file
ARCH * fzeropk0;
ARCH * fzeropk1;
ARCH * fzeropk2;
ARCH * fzerodt0;


//strings
const char * fstpath[] = {
	"sprites\\blueflcn\\fstplane",
	"sprites\\goldnfox\\fstplane",
	"sprites\\wildgoos\\fstplane",
	"sprites\\firestgr\\fstplane"
};

const char * firepath[] = {
	"sprites\\blueflcn\\fire",
	"sprites\\goldnfox\\fire",
	"sprites\\wildgoos\\fire",
	"sprites\\firestgr\\fire"
};

const char * scaledpath[] = {
	"sprites\\blueflcn\\scaled",
	"sprites\\goldnfox\\scaled",
	"sprites\\wildgoos\\scaled",
	"sprites\\firestgr\\scaled"
};

const unsigned char * styles[] = {
	"mutecity",
	"bigblue",
	"porttown",
	"whitland",
	"sndocean",
	"silence",
	"deathwnd",
	"redcanyn",
	"firfield"
};


//track & map
Track track;
char trackfilename[] = "tracks\\track\0\0\0";
unsigned short nbfx;
unsigned char * effects;
ExtraMap * xm;
unsigned short * WPM;
const char selection[] = {0,15,17,41,60,63,67,68,86};
const char fill_with[] = {0,0,23,0,1,0,0,0,0};


//save
save_struct * save;


//menu
unsigned char mp[3*32*4];
masterp mparam;
slavep sparam;
ghostp gparam;
slavep * player;
unsigned char ghostloaded;


//gameplay
Machine machines[MAX_MACHINES];
const unsigned short stats[4][7] = {
{1260,'B','C','B',25,350,14},  // bf	1 260 KG BODY B BOOST C GRIP B ACCEL 2.5 MAXSPEED 3   CORNERING 4
{1420,'D','A','D',40,330,13},  // gf	1 420 KG BODY D BOOST A GRIP D ACCEL 4   MAXSPEED 2   CORNERING 3
{1520,'A','B','C',10,350,12},  // wg	1 520 KG BODY A BOOST B GRIP C ACCEL 1   MAXSPEED 3   CORNERING 2.5
{1660,'A','D','B',10,370,11}}; // fs	1 660 KG BODY A BOOST D GRIP B ACCEL 1   MAXSPEED 5   CORNERING 2
unsigned short Gravity;
unsigned char rank[MAX_MACHINES]; // rank [player,other,other,other] || [master,slave,other,other]
unsigned char sel_machines[MAX_MACHINES];
unsigned char sprites_id[MAX_MACHINES];
unsigned char balance_tab[MAX_MACHINES];
unsigned char controlled_tab[MAX_MACHINES];
unsigned char nb_machines;
unsigned char end_race_status;
unsigned char lapbuff[] = "LAP */*";
volatile unsigned char HudChange, MapChange, EnergyChange, LapChange, RankChange;
volatile unsigned char revevent;
volatile unsigned char boostevent;


//HUD
unsigned char hudscreen[OFFSET_SKY_VERT*30];


//ghost
unsigned char * ghost_record_buffer;
unsigned char * ghost_record_buffer_current;
unsigned char hold;
volatile unsigned short ghost_record;
