// Header File
// Created 02/08/2004; 12:51:58

#ifndef PHYSICS_H
#define PHYSICS_H

#include "game.h"

typedef struct Vect {
	short dir;
	short norm;
}Vect;

void setGravity (unsigned short g);
void vectAdd (Vect * v1, Vect * v2, Vect * v3); // v3 = v1 + v2
void translate (short * x, short * y, Vect * v);
void collide (Vect * inertia, short obstacle_orientation, Vect * extForce);
void collide_ship (Vect * inertia, short obstacle_orientation, Vect * extForce, short norm);
void thrustToInertia(Vect * v1, Vect * v2, unsigned char slide, short * dirs);

#endif
