setlocal

set SWITCHES=-Os -Wall -W -Wwrite-strings -ffunction-sections -fdata-sections -WA,-g,-t --optimize-nops --optimize-returns --optimize-branches --optimize-moves --optimize-tests --optimize-calcs --remove-unused --cut-ranges --reorder-sections  --merge-constants -DOPTIMIZE_CALC_CONSTS -DMIN_AMS=100 -DKERNEL_FORMAT_BSS -DKERNEL_FORMAT_DATA_VAR
set SOURCES=main.c mode7.c m7sprites.c m7link.c map.c mem.c arch.c huffman.c game.c track.c physics.c menu.c kbd200.c kbd92.c kbd89.c gameplay.c hud.c fastdigit.c
set OBJECTS=main.o mode7.o m7sprites.o m7link.o map.o mem.o arch.o huffman.o game.o track.o physics.o menu.o kbd200.o kbd92.o kbd89.o gameplay.o hud.o fastdigit.o

tigcc %SOURCES% -c %SWITCHES%
tigcc %OBJECTS% -o "%1" -pack fzeroppg -n fzero %SWITCHES%

endlocal


