// Header File
// Created 13/02/2005; 10:20:50

#ifndef LINK_H
#define LINK_H

#define TIMEOUT 256
#define USBPARAM 2000
#define TIMED_OUT (timeout == TIMEOUT)

extern unsigned char linkenabled; // 0 : disabled, 1 : enabled
extern unsigned char linkmode; // 0 : slave, 1 : master
extern unsigned char linktype; // 0 : LIO, 1 : USB (not implemented yet)
extern unsigned char send, recv;
extern volatile unsigned char received;
extern volatile unsigned short timeout;

void m7Link_SetFunc(void (*FillSend)(void));
void m7Link_SetBreakFunc(char (*Break)(void));
void m7Link_Flush(void);
char m7Link_Connect(void);
void timeIncr(void);
void masterModif(void);
void slaveModif(void);
void LinkRecv(void);

#endif
