// C Source File
// Created 18/04/2005; 16:15:49

#include <tigcclib.h>
#include "uncompress.h"

typedef struct node {
	unsigned char l_id;
	unsigned char r_id;
	struct node * l_node;
	struct node * r_node;
} node;

unsigned char * comp;
unsigned char numbit;
node * nod;

unsigned char rbit() {
	if(!((++numbit) & 0x7)) {++comp;numbit=0;}
	return *comp & (0x80 >> numbit);
}

unsigned char rid() {
	unsigned short i;
	unsigned char id=0;
	for(i=8;i--;)
		id <<= 1, id |= (rbit()?1:0);
	return id;
}

node * mtree_read(unsigned char * id) {
	node * n = nod;
	if(rbit()) { *id = rid(); return NULL;	}
	nod++;
	n->l_node = mtree_read(&(n->l_id));
	n->r_node = mtree_read(&(n->r_id));
	return n;
}

unsigned char rcode(node * n) {
	if(!rbit()) {
		if(!(n->l_node)) return n->l_id;
		else return rcode(n->l_node);
	}
	if(!(n->r_node)) return n->r_id;
	else return rcode(n->r_node);
}

unsigned char * uncompress(unsigned char * dataComp, unsigned short * size) {
	unsigned char * data;
	node nodes[255];
	nod = nodes;
	comp = dataComp+1;
	numbit = 7;
	mtree_read(NULL);
	*size = *(unsigned short*)dataComp;
	data = (unsigned char *)malloc(sizeof(unsigned char) * (*size)); // gerer ca avec realloc etc..
	unsigned short i;
	for(i=0;i<(*size);i++)
		data[i] = rcode(nodes);
	return data;
}
